> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nudj.cx/llms.txt
> Use this file to discover all available pages before exploring further.

# Challenge action steps (funnel)

> Ordered challenge steps with participation breakdown.



## OpenAPI

````yaml /openapi/analytics.json get /challenges/stats/action-steps
openapi: 3.1.0
info:
  title: Nudj Analytics API
  version: 1.0.0
servers:
  - url: https://{subdomain}.nudj.cx/api/v2/analytics
    description: Organization API Server
    variables:
      subdomain:
        description: Your organization's subdomain (required)
        default: your-org
security: []
paths:
  /challenges/stats/action-steps:
    get:
      tags:
        - Challenge
      summary: Challenge action steps (funnel)
      description: Ordered challenge steps with participation breakdown.
      operationId: getChallengeActionSteps
      parameters:
        - in: query
          name: challengeId
          schema:
            type: string
          required: true
        - in: query
          name: startDate
          schema:
            type: string
        - in: query
          name: endDate
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                type: object
                properties:
                  steps:
                    type: array
                    items:
                      type: object
                      properties:
                        actionId:
                          type: string
                        actionTitle:
                          type: string
                        stepIndex:
                          type: number
                        completionRate:
                          type: number
                        totalCompletions:
                          type: number
                        dropOffRate:
                          type: number
                        actionKey:
                          type: string
                        category:
                          type: string
                        criteriaMetCount:
                          type: number
                        criteriaNotMetCount:
                          type: number
                        totalAttempts:
                          type: number
                        uniqueUsersCount:
                          type: number
                      required:
                        - actionId
                        - actionTitle
                        - stepIndex
                        - completionRate
                        - totalCompletions
                        - dropOffRate
                        - criteriaMetCount
                        - criteriaNotMetCount
                        - totalAttempts
                        - uniqueUsersCount
                required:
                  - steps
        '400':
          description: Invalid input data
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error.BAD_REQUEST'
        '404':
          description: Not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error.NOT_FOUND'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error.INTERNAL_SERVER_ERROR'
components:
  schemas:
    error.BAD_REQUEST:
      type: object
      properties:
        message:
          type: string
          description: The error message
          example: Invalid input data
        code:
          type: string
          description: The error code
          example: BAD_REQUEST
        issues:
          type: array
          items:
            type: object
            properties:
              message:
                type: string
            required:
              - message
          description: An array of issues that were responsible for the error
          example: []
      required:
        - message
        - code
      title: Error
      description: The error information
      example:
        code: BAD_REQUEST
        message: Invalid input data
        issues: []
    error.NOT_FOUND:
      type: object
      properties:
        message:
          type: string
          description: The error message
          example: Not found
        code:
          type: string
          description: The error code
          example: NOT_FOUND
        issues:
          type: array
          items:
            type: object
            properties:
              message:
                type: string
            required:
              - message
          description: An array of issues that were responsible for the error
          example: []
      required:
        - message
        - code
      title: Error
      description: The error information
      example:
        code: NOT_FOUND
        message: Not found
        issues: []
    error.INTERNAL_SERVER_ERROR:
      type: object
      properties:
        message:
          type: string
          description: The error message
          example: Internal server error
        code:
          type: string
          description: The error code
          example: INTERNAL_SERVER_ERROR
        issues:
          type: array
          items:
            type: object
            properties:
              message:
                type: string
            required:
              - message
          description: An array of issues that were responsible for the error
          example: []
      required:
        - message
        - code
      title: Error
      description: The error information
      example:
        code: INTERNAL_SERVER_ERROR
        message: Internal server error
        issues: []

````